Unit AST5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AST5R(var IU :Array of Integer; var JU :Array of Integer;
                var UN :Array of Real; var X :Array of Real;
                N :Integer; var B :Array of Real);

implementation

procedure AST5R(var IU :Array of Integer; var JU :Array of Integer;
                var UN :Array of Real; var X :Array of Real;
                N :Integer; var B :Array of Real);
var
NM,I,IUA,IUB,IP,J :Integer;
Z :Real;
label
_10,_20,_30;
begin

{            - }
{        U'X=B,  U' -    }
{         ,    RR(U)U. }


{   IU, JU, UN - E      - }
{                  U     - }
{                 RR(U)U; }

{            X -     N,  }
{                   ; }

{            N -    (: ); }

{            B -     N,  }
{                     }

NM := N-1;

{        B   X }

for I:=1 to N do
 begin
_10:
  X[I-1] := B[I-1];
 end;

{            U }

for I:=1 to NM do
 begin
  IUA := IU[I-1];
  IUB := IU[I+0]-1;
  if ( IUB < IUA ) 
   then goto _30;

{        I  X,   I  U }
{       }

  Z := X[I-1];
  for IP:=IUA to IUB do
   begin
    J := JU[IP-1];
_20:
    X[J-1] := X[J-1]-Z*UN[IP-1];
   end;
_30:
 end;
end;

end.
